/*DROP DATABASE `virtualCommunities`;*/


CREATE DATABASE `virtualCommunities`; /*Create a dataBase*/
USE `virtualCommunities`; /*Specified that I will use this database to put the next tables*/

/*Create tables of the database*/
CREATE TABLE IF NOT EXISTS `user`(
`id` int(11) PRIMARY KEY AUTO_INCREMENT,
`name` varchar(20),
`surname` varchar(20),
`password` varchar(8) NOT NULL,
`active` bool NOT NULL DEFAULT 1,
`nickname` varchar(20),
`mail` varchar(20)
)ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `section_type`(
`id` int(11) PRIMARY KEY AUTO_INCREMENT,
`type` varchar(20) /*Spam, violent, ok, porn*/
)ENGINE=InnoDB;


CREATE TABLE IF NOT EXISTS `content_type`(
`id` int(11) PRIMARY KEY AUTO_INCREMENT,
`type` varchar(20) /*Spam, violent, ok, porn*/
)ENGINE=InnoDB;


CREATE TABLE IF NOT EXISTS `content`(
`id` int(11) PRIMARY KEY AUTO_INCREMENT,
`content_type` int(11) REFERENCES `content_type`(`id`),
`section_type` int(11) REFERENCES `section_type`(`id`),
`file` varchar(20), /*Video, image or text*/
`url` varchar(100),
`message`varchar(100)
)ENGINE=InnoDB;


CREATE TABLE IF NOT EXISTS `complain_type`(
`id` int(11) PRIMARY KEY AUTO_INCREMENT,
`type` varchar(20)
)ENGINE=InnoDB;


CREATE TABLE IF NOT EXISTS `complain`(
`id` int(11) PRIMARY KEY AUTO_INCREMENT,
`id_user` int(11) REFERENCES `user`(`id`),
`id_content` int(11) REFERENCES `content`(`id`),
`id_complain_type` int(11) REFERENCES `complain_type`(`id`),
`reply` varchar(100)
)ENGINE=InnoDB;


CREATE TABLE IF NOT EXISTS `user_content`(
`id_user` int(11) REFERENCES `user`(`id`),
`id_content` int(11) REFERENCES `content`(`id`),
PRIMARY KEY(`id_user`, `id_content`)
)ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `agent_profile`(
`id_profile` int(11) PRIMARY KEY AUTO_INCREMENT,
`name` varchar(100),
`correct` decimal(9,2),
`wrongPlacement` decimal(9,2),
`insult` decimal(9,2),
`spam` decimal(9,2),
`violent` decimal(9,2),
`porn` decimal(9,2),
`upLoadContent` decimal(9,2),
`forum` decimal(9,2),
`theReporter` decimal(9,2),
`photoVideo` decimal(9,2),
`viewMode` decimal(9,2),
`distributionMode` decimal(9,2),
`wrongPlacementComplaint` decimal(9,2),
`insultComplaint` decimal(9,2),
`spamComplaint` decimal(9,2),
`violentComplaint` decimal(9,2),
`pornComplaint` decimal(9,2),
`population` varchar(100)
)ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `agent_type`(
`id_agent_type` int(11) PRIMARY KEY AUTO_INCREMENT,
`typeName` varchar(100)
)ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `agent_population`(
`id_agent_population` int(11) PRIMARY KEY AUTO_INCREMENT,
`populationName` varchar(100)
)ENGINE=InnoDB;

CREATE TABLE IF NOT EXISTS `population`(
`id_agent_type` int(11) REFERENCES `agent_type`(`id_agent_type`),
`id_agent_profile` int(11) REFERENCES `agent_profile`(`id_profile`),
`id_population` int(11) REFERENCES `agent_population`(`id_agent_population`),
`quantity` int(11),
PRIMARY KEY(`id_agent_type`, `id_agent_profile`, `id_population`)
)ENGINE=InnoDB;