package social.context;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Random;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.UIManager;

import social.agents.Agent;
import social.bbdd.BbddManager;
import social.agents.profile.ComplaintProfile;
import social.agents.profile.UploadProfile;
import social.agents.profile.ViewProfile;

/**
 * Window to configure agents
 * @author Iosu mendizabal
 *
 */
public class ConfigureAgentWindow extends JDialog implements ActionListener{
	
	private static final long serialVersionUID = 1L;
	private JComboBox AgentCombo;
	private JComboBox PopulationCombo;
	
	private JLabel ForumViewLabel;
	private JLabel ModerateImage;
	private JLabel AgentNameLabel;
	private JLabel AgentTypeLabel;
	private JLabel PornComplaintLabel;
	private JLabel ViolentComplaintLabel;
	private JLabel SpamComplaintLabel;
	private JLabel InsultComplaintLabel;
	private JLabel WrongPlacementComplaintLabel;
	private JLabel MultimediaViewLabel;
	private JLabel ReporterViewLabel;
	private JLabel PornContentLabel;
	private JLabel PopulationLabel;
	private JLabel NumberOfAgentsLabel;
	private JLabel ViolentLabel;
	private JLabel TrollLabel;
	private JLabel SpammerLabel;
	private JLabel RudeLabel;
	private JLabel PornographicLabel;
	private JLabel ModerateLabel;
	private JLabel CorrectContentLabel;
	private JLabel ViolentContentLabel;
	private JLabel SpamContentLabel;
	private JLabel InsultContentLabel;
	private JLabel WrongPlacementContentLabel;
	private JLabel UploadContentLabel;
	private JLabel UploadProfile;
	private JLabel populationLabel;
	private JLabel ComplaintProfile;
	private JLabel ViewProfile;
	private JLabel SumaLabel;
	private JLabel ViewModeLabel;
	
	private JTextField ViolentComplaintPer;
	private JTextField ViolentAgentNumber;
	private JTextField newPopulationName;
	private JTextField PornComplaintPer;
	private JTextField TrollAgentNumber;
	private JTextField SpammerAgentNumber;
	private JTextField RudeAgentNumber;
	private JTextField PornoAgentNumber;
	private JTextField ModerateAgentNumber;
	private JTextField NumberOfAgents;
	private JTextField SpamComplaintPer;
	private JTextField InsultComplaintPer;
	private JTextField WrongComplaintPer;
	private JTextField MultimediaPer;
	private JTextField ReporterPer;
	private JTextField ForumPer;
	private JTextField PornPer;
	private JTextField ViolentPer;
	private JTextField SpammPer;
	private JTextField InsultPer;
	private JTextField WrongPlacePer;
	private JTextField CorrectPer;
	private JTextField UploadPercentage;
	
	private JButton ChangeButton;
	private JButton SaveButton;
	private JButton ExitButton;
	
	private JSeparator Separator;
	
	private JRadioButton ByRandomRadio;
	private JRadioButton ByMostViewRadio;
	private JRadioButton ByOrderRadio;

	//Database connection
	protected BbddManager bbddManager;
	
	private ArrayList<Agent> agente = new ArrayList<Agent>();
	private UploadProfile uploadProfile;
	private ViewProfile viewProfile;
	private ComplaintProfile complaintProfile;
	private Random randomUpload;
	private ContextData contextData;
	
	
	public ConfigureAgentWindow(JFrame parent, boolean modal){
		super(parent, modal);
		bbddManager = new BbddManager();
		initGUI();
		cargarDatosComboBox();		
		setSize(926, 726);
		setLocationRelativeTo(null);// Situa la ventana en la mitad de la pantalla
		setVisible(true);
	}
	
	public void initGUI() {
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch(Exception e) {
			e.printStackTrace();
		}
		try {
			getContentPane().setLayout(null);
					
			ComboBoxModel PopulationComboModel =  new DefaultComboBoxModel();
			PopulationCombo = new JComboBox();
			getContentPane().add(PopulationCombo);
			PopulationCombo.setModel(PopulationComboModel);
			PopulationCombo.setBounds(366, 22, 190, 22);
			PopulationCombo.addActionListener(this);
			
			ComboBoxModel AgentComboModel =  new DefaultComboBoxModel();
			AgentCombo = new JComboBox();
			getContentPane().add(AgentCombo);
			AgentCombo.setModel(AgentComboModel);
			AgentCombo.setBounds(366, 56, 190, 22);
			AgentCombo.addActionListener(this);
			
			
			UploadProfile = new JLabel();
			getContentPane().add(UploadProfile);
			UploadProfile.setText("Upload Profile");
			UploadProfile.setBounds(110, 134, 144, 15);
			UploadProfile.setFont(new java.awt.Font("Dialog",1,16));
			
			
			ViewProfile = new JLabel();
			getContentPane().add(ViewProfile);
			ViewProfile.setText("View Profile");
			ViewProfile.setBounds(381, 134, 122, 15);
			ViewProfile.setFont(new java.awt.Font("Dialog",1,16));
			
			
			ComplaintProfile = new JLabel();
			getContentPane().add(ComplaintProfile);
			ComplaintProfile.setText("Complaint Profile");
			ComplaintProfile.setBounds(643, 134, 155, 15);
			ComplaintProfile.setFont(new java.awt.Font("Dialog",1,16));
		
			
			UploadPercentage = new JTextField();
			getContentPane().add(UploadPercentage);
			UploadPercentage.setBounds(223, 167, 45, 19);
			
			
			CorrectPer = new JTextField();
			getContentPane().add(CorrectPer);
			CorrectPer.setBounds(223, 205, 45, 19);
			
			WrongPlacePer = new JTextField();
			getContentPane().add(WrongPlacePer);
			WrongPlacePer.setBounds(223, 236, 45, 19);
			
			
			InsultPer = new JTextField();
			getContentPane().add(InsultPer);
			InsultPer.setBounds(223, 267, 45, 19);
			
			
			SpammPer = new JTextField();
			getContentPane().add(SpammPer);
			SpammPer.setBounds(223, 298, 45, 19);
			SpammPer.setToolTipText("TEST");
			
			
			ViolentPer = new JTextField();
			getContentPane().add(ViolentPer);
			ViolentPer.setBounds(223, 325, 45, 19);
			
			
			PornPer = new JTextField();
			getContentPane().add(PornPer);
			PornPer.setBounds(223, 360, 45, 19);
			
			
			ForumPer = new JTextField();
			getContentPane().add(ForumPer);
			ForumPer.setBounds(512, 168, 45, 19);
			
			
			ReporterPer = new JTextField();
			getContentPane().add(ReporterPer);
			ReporterPer.setBounds(512, 201, 45, 19);
			
			
			MultimediaPer = new JTextField();
			getContentPane().add(MultimediaPer);
			MultimediaPer.setBounds(512, 232, 45, 19);
			
			
			WrongComplaintPer = new JTextField();
			getContentPane().add(WrongComplaintPer);
			WrongComplaintPer.setBounds(804, 170, 45, 19);
			
			
			InsultComplaintPer = new JTextField();
			getContentPane().add(InsultComplaintPer);
			InsultComplaintPer.setBounds(804, 201, 45, 19);
			
			
			SpamComplaintPer = new JTextField();
			getContentPane().add(SpamComplaintPer);
			SpamComplaintPer.setBounds(804, 232, 45, 19);
			
			
			ViolentComplaintPer = new JTextField();
			getContentPane().add(ViolentComplaintPer);
			ViolentComplaintPer.setBounds(804, 263, 45, 19);
			
			
			PornComplaintPer = new JTextField();
			getContentPane().add(PornComplaintPer);
			PornComplaintPer.setBounds(804, 294, 45, 19);
			
			
			UploadContentLabel = new JLabel();
			getContentPane().add(UploadContentLabel);
			UploadContentLabel.setText("Upload Frequency");
			UploadContentLabel.setBounds(79, 170, 112, 15);
			
			
			CorrectContentLabel = new JLabel();
			getContentPane().add(CorrectContentLabel);
			CorrectContentLabel.setText("Correct Content");
			CorrectContentLabel.setBounds(82, 207, 113, 15);
			
			
			WrongPlacementContentLabel = new JLabel();
			getContentPane().add(WrongPlacementContentLabel);
			WrongPlacementContentLabel.setText("Wrong Placement");
			WrongPlacementContentLabel.setBounds(82, 238, 122, 15);
			
			
			InsultContentLabel = new JLabel();
			getContentPane().add(InsultContentLabel);
			InsultContentLabel.setText("Insult Content");
			InsultContentLabel.setBounds(82, 269, 101, 15);
			
			
			SpamContentLabel = new JLabel();
			getContentPane().add(SpamContentLabel);
			SpamContentLabel.setText("Spam Content");
			SpamContentLabel.setBounds(82, 300, 103, 15);
		
			
			ViolentContentLabel = new JLabel();
			getContentPane().add(ViolentContentLabel);
			ViolentContentLabel.setText("Violent Content");
			ViolentContentLabel.setBounds(82, 331, 110, 15);
			
			
			PornContentLabel = new JLabel();
			getContentPane().add(PornContentLabel);
			PornContentLabel.setText("Porn Content");
			PornContentLabel.setBounds(82, 362, 97, 15);
			

			ForumViewLabel = new JLabel();
			getContentPane().add(ForumViewLabel);
			ForumViewLabel.setText("Forum View");
			ForumViewLabel.setBounds(372, 170, 108, 15);
			
			
			ReporterViewLabel = new JLabel();
			getContentPane().add(ReporterViewLabel);
			ReporterViewLabel.setText("The Reporter View");
			ReporterViewLabel.setBounds(372, 203, 123, 15);
			
			
			MultimediaViewLabel = new JLabel();
			getContentPane().add(MultimediaViewLabel);
			MultimediaViewLabel.setText("Multimedia View");
			MultimediaViewLabel.setBounds(372, 234, 123, 15);
			
			
			WrongPlacementComplaintLabel = new JLabel();
			getContentPane().add(WrongPlacementComplaintLabel);
			WrongPlacementComplaintLabel.setText("Wrong Placement Complaint");
			WrongPlacementComplaintLabel.setBounds(615, 172, 177, 15);
			
		
			InsultComplaintLabel = new JLabel();
			getContentPane().add(InsultComplaintLabel);
			InsultComplaintLabel.setText("Insult Complaint");
			InsultComplaintLabel.setBounds(615, 203, 108, 15);
			
		
			SpamComplaintLabel = new JLabel();
			getContentPane().add(SpamComplaintLabel);
			SpamComplaintLabel.setText("Spam Complaint");
			SpamComplaintLabel.setBounds(615, 234, 110, 15);
			
		
			ViolentComplaintLabel = new JLabel();
			getContentPane().add(ViolentComplaintLabel);
			ViolentComplaintLabel.setText("Violent Complaint");
			ViolentComplaintLabel.setBounds(615, 265, 117, 15);
			
			
			PornComplaintLabel = new JLabel();
			getContentPane().add(PornComplaintLabel);
			PornComplaintLabel.setText("Porn Complaint");
			PornComplaintLabel.setBounds(615, 296, 104, 15);
			
			
			PopulationLabel = new JLabel();
			getContentPane().add(PopulationLabel);
			PopulationLabel.setText("Actual Population");
			PopulationLabel.setBounds(90, 455, 753, 32);
			PopulationLabel.setFont(new java.awt.Font("Dialog",1,18));
			PopulationLabel.setBorder(BorderFactory.createTitledBorder(""));
			
			
			ModerateLabel = new JLabel();
			getContentPane().add(ModerateLabel);
			ModerateLabel.setText("Moderate");
			ModerateLabel.setBounds(187, 525, 110, 15);
			
			
			PornographicLabel = new JLabel();
			getContentPane().add(PornographicLabel);
			PornographicLabel.setText("Pornographic");
			PornographicLabel.setBounds(187, 554, 110, 15);
		
		
			RudeLabel = new JLabel();
			getContentPane().add(RudeLabel);
			RudeLabel.setText("Rude");
			RudeLabel.setBounds(187, 582, 94, 15);
			
			
			SpammerLabel = new JLabel();
			getContentPane().add(SpammerLabel);
			SpammerLabel.setText("Spammer");
			SpammerLabel.setBounds(549, 522, 99, 15);
			
			
			TrollLabel = new JLabel();
			getContentPane().add(TrollLabel);
			TrollLabel.setText("Troll");
			TrollLabel.setBounds(549, 552, 99, 15);
			
			
			ViolentLabel = new JLabel();
			getContentPane().add(ViolentLabel);
			ViolentLabel.setText("Violent");
			ViolentLabel.setBounds(549, 582, 120, 15);
			
			
			NumberOfAgents = new JTextField();
			getContentPane().add(NumberOfAgents);
			NumberOfAgents.setBounds(511, 408, 45, 19);
			
			
			NumberOfAgentsLabel = new JLabel();
			getContentPane().add(NumberOfAgentsLabel);
			NumberOfAgentsLabel.setText("Number of Agents");
			NumberOfAgentsLabel.setBounds(333, 411, 138, 15);
			
			
			ChangeButton = new JButton();
			getContentPane().add(ChangeButton);
			ChangeButton.setText("Modify");
			ChangeButton.setBounds(602, 407, 119, 25);
			ChangeButton.addActionListener(this);
			ChangeButton.setActionCommand("modificar");
			
		
			ModerateAgentNumber = new JTextField();
			getContentPane().add(ModerateAgentNumber);
			ModerateAgentNumber.setBounds(359, 523, 39, 17);
			ModerateAgentNumber.setEditable(false);

			PornoAgentNumber = new JTextField();
			getContentPane().add(PornoAgentNumber);
			PornoAgentNumber.setBounds(359, 552, 39, 17);
			PornoAgentNumber.setEditable(false);

			RudeAgentNumber = new JTextField();
			getContentPane().add(RudeAgentNumber);
			RudeAgentNumber.setBounds(359, 580, 39, 17);
			RudeAgentNumber.setEditable(false);

			SpammerAgentNumber = new JTextField();
			getContentPane().add(SpammerAgentNumber);
			SpammerAgentNumber.setBounds(721, 522, 39, 17);
			SpammerAgentNumber.setEditable(false);

			TrollAgentNumber = new JTextField();
			getContentPane().add(TrollAgentNumber);
			TrollAgentNumber.setBounds(721, 552, 39, 17);
			TrollAgentNumber.setEditable(false);

			ViolentAgentNumber = new JTextField();
			getContentPane().add(ViolentAgentNumber);
			ViolentAgentNumber.setBounds(721, 582, 39, 17);
			ViolentAgentNumber.setEditable(false);

			ExitButton = new JButton();
			getContentPane().add(ExitButton);
			ExitButton.setText("Exit and Start");
			ExitButton.setBounds(398, 639, 127, 29);
			ExitButton.addActionListener(this);    
			ExitButton.setActionCommand("ExitButton");
			
			
			newPopulationName = new JTextField();
			getContentPane().add(newPopulationName);
			newPopulationName.setBounds(725, 18, 155, 28);
			
			
			AgentTypeLabel = new JLabel();
			getContentPane().add(AgentTypeLabel);
			AgentTypeLabel.setText("Agent Type");
			AgentTypeLabel.setBounds(221, 58, 106, 16);
			
			
			AgentNameLabel = new JLabel();
			getContentPane().add(AgentNameLabel);
			AgentNameLabel.setText("New Population Name");
			AgentNameLabel.setBounds(573, 24, 140, 16);
			
 
			ImageIcon icon = new ImageIcon("graphics/icons/agents/moderate_agent.png");			
			ModerateImage = new JLabel();
			getContentPane().add(ModerateImage);
			ModerateImage.setIcon(icon);
			ModerateImage.setBounds(122, 519, 39, 17);

			
			icon = new ImageIcon("graphics/icons/agents/pornographic_agent.png");			
			JLabel PornoImage = new JLabel();
			getContentPane().add(PornoImage);
			PornoImage.setIcon(icon);
			PornoImage.setBounds(123, 548, 39, 17);
			
			icon = new ImageIcon("graphics/icons/agents/rude_agent.png");			
			JLabel rudeImage = new JLabel();
			getContentPane().add(rudeImage);
			rudeImage.setIcon(icon);
			rudeImage.setBounds(123, 578, 39, 17);
			
			icon = new ImageIcon("graphics/icons/agents/spammer_agent.png");			
			JLabel SpammerImage = new JLabel();
			getContentPane().add(SpammerImage);
			SpammerImage.setIcon(icon);
			SpammerImage.setBounds(486, 519, 39, 17);
			
			icon = new ImageIcon("graphics/icons/agents/troll_agent.png");			
			JLabel TrollImage = new JLabel();
			getContentPane().add(TrollImage);
			TrollImage.setIcon(icon);
			TrollImage.setBounds(486, 548, 39, 17);
			
			icon = new ImageIcon("graphics/icons/agents/violent_agent.png");			
			JLabel ViolentImage = new JLabel();
			getContentPane().add(ViolentImage);
			ViolentImage.setIcon(icon);
			ViolentImage.setBounds(486, 578, 39, 17);
			
			populationLabel = new JLabel();
			getContentPane().add(populationLabel);
			populationLabel.setText("Population");
			populationLabel.setBounds(221, 23, 106, 16);
			
			
			SaveButton = new JButton();
			getContentPane().add(SaveButton);
			SaveButton.setText("Save Population");
			SaveButton.setBounds(731, 53, 139, 32);
			SaveButton.addActionListener(this);
			SaveButton.setActionCommand("SaveButton");
			
			SumaLabel = new JLabel();
			getContentPane().add(SumaLabel);
			SumaLabel.setBounds(215, 367, 10, 10);
			
			ViewModeLabel = new JLabel();
			getContentPane().add(ViewModeLabel);
			ViewModeLabel.setText("View Mode");
			ViewModeLabel.setBounds(377, 275, 99, 16);
			ViewModeLabel.setFont(new java.awt.Font("Lucida Grande",1,16));
			
			
			ByOrderRadio = new JRadioButton();
			getContentPane().add(ByOrderRadio);
			ByOrderRadio.setText("By Order");
			ByOrderRadio.setBounds(383, 306, 85, 23);
			ByOrderRadio.addActionListener(this);
			
			
			ByMostViewRadio = new JRadioButton();
			getContentPane().add(ByMostViewRadio);
			ByMostViewRadio.setText("By Most View");
			ByMostViewRadio.setBounds(383, 330, 114, 23);
			ByMostViewRadio.addActionListener(this);
			
			
			ByRandomRadio = new JRadioButton();
			getContentPane().add(ByRandomRadio);
			ByRandomRadio.setText("By Random");
			ByRandomRadio.setBounds(383, 356, 101, 23);
			ByRandomRadio.addActionListener(this);
		
			ButtonGroup group = new ButtonGroup();
			
			group.add(ByOrderRadio);
			group.add(ByMostViewRadio);
			group.add(ByRandomRadio);
		
			Separator = new JSeparator();
			getContentPane().add(Separator);
			Separator.setBounds(57, 189, 261, 12);
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	private void cargarDatosComboBox() {
		bbddManager.establishedConnection("Load date combo box");
		if(bbddManager.getConn()!=null){
			ArrayList<String> popuName = bbddManager.getPopulations();
			for(int i = 0 ; i < popuName.size() ; i++){
				PopulationCombo.addItem(popuName.get(i));
			}		
			bbddManager.terminatedConnection("");
		}
		
		bbddManager.establishedConnection("");
		if(bbddManager.getConn()!=null){
			ArrayList<String> agentTypeName = bbddManager.getAgentTypes();
			for(int i = 0 ; i < agentTypeName.size() ; i++){
				AgentCombo.addItem(agentTypeName.get(i));
			}	
			bbddManager.terminatedConnection("");
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == PopulationCombo) {
			cargarArrayAgenteSegunPoblacion();
			visualizarInformacionAgente();
		}
		
		if (e.getSource() == AgentCombo) {
			visualizarInformacionAgente();		
		}
		
		if (e.getActionCommand().equals("modificar")){
			boolean comprobacion = comprobarValores();
			if(comprobacion){
				guardarCambiosEnArrayAgente();
			}
		}
		
		if(e.getActionCommand().equals("SaveButton")){
			guardarCambiosEnBD();
		}

		if (e.getActionCommand().equals("ExitButton")) {
			this.dispose();
		}
	}

	private void cargarArrayAgenteSegunPoblacion() {
		agente.removeAll(agente);
		bbddManager.establishedConnection("");
		if(bbddManager.getConn()!=null){
			agente = bbddManager.getAgentsProfile(contextData, uploadProfile, viewProfile, complaintProfile, randomUpload, ""+PopulationCombo.getSelectedItem());
			bbddManager.terminatedConnection("");
		}
	}

	private void guardarCambiosEnBD() {
		bbddManager.establishedConnection("Configure Agent Window");
		if(bbddManager.getConn()!=null){
			bbddManager.setNewAgentPopulation(agente, newPopulationName.getText());
			bbddManager.terminatedConnection("Configure Agent Window");
		}
		JOptionPane optionPane = new JOptionPane();
		optionPane.setMessage("The changes have been saved in the database.");
		optionPane.setMessageType(JOptionPane.INFORMATION_MESSAGE);
		JDialog dialog = optionPane.createDialog(null, "Information Dialog");
		dialog.setVisible(true);
	}

	private void guardarCambiosEnArrayAgente() {
		for(int i = 0 ; i < agente.size() ; i++){
			if(AgentCombo.getSelectedItem().equals(agente.get(i).getName()) && PopulationCombo.getSelectedItem().equals(agente.get(i).getPopulation())){
				
				agente.get(i).getUp().setUpLoadContent(Double.parseDouble(UploadPercentage.getText()));
				agente.get(i).getUp().setCorrect(Double.parseDouble(CorrectPer.getText()));
				agente.get(i).getUp().setWrongPlacement(Double.parseDouble(WrongPlacePer.getText()));
				agente.get(i).getUp().setInsult(Double.parseDouble(this.InsultPer.getText()));
				agente.get(i).getUp().setSpam(Double.parseDouble(this.SpammPer.getText()));
				agente.get(i).getUp().setViolent(Double.parseDouble(this.ViolentPer.getText()));
				agente.get(i).getUp().setPorn(Double.parseDouble(this.PornPer.getText()));
				
				agente.get(i).getVp().setForum(Double.parseDouble(this.ForumPer.getText()));
				agente.get(i).getVp().setTheReporter(Double.parseDouble(this.ReporterPer.getText()));
				agente.get(i).getVp().setPhotoVideo(Double.parseDouble(this.MultimediaPer.getText()));
				
				agente.get(i).getCp().setWrongPlacement(Double.parseDouble(this.WrongComplaintPer.getText()));
				agente.get(i).getCp().setInsult(Double.parseDouble(this.InsultComplaintPer.getText()));
				agente.get(i).getCp().setSpam(Double.parseDouble(this.SpamComplaintPer.getText()));
				agente.get(i).getCp().setViolent(Double.parseDouble(this.ViolentComplaintPer.getText()));
				agente.get(i).getCp().setPorn(Double.parseDouble(this.PornComplaintPer.getText()));
				
				agente.get(i).setQuantity(Integer.parseInt(this.NumberOfAgents.getText()));
				
				if(agente.get(i).getName().equals("Moderate")){
					this.ModerateAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Pornographic")){
					this.PornoAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Rude")){
					this.RudeAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Spammer")){
					this.SpammerAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Troll")){
					this.TrollAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Violent")){
					this.ViolentAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				
				if(ByMostViewRadio.isSelected()){
					agente.get(i).getVp().setViewMode(1);
				}
				if(ByOrderRadio.isSelected()){
					agente.get(i).getVp().setViewMode(0);
				}
				if(ByRandomRadio.isSelected()){
					agente.get(i).getVp().setViewMode(2);
				}
			}
		}
		
		JOptionPane optionPane = new JOptionPane();
		optionPane.setMessage("The changes have been saved.");
		optionPane.setMessageType(JOptionPane.INFORMATION_MESSAGE);
		JDialog dialog = optionPane.createDialog(null, "Information Dialog");
		dialog.setVisible(true);
		
	}

	private boolean comprobarValores() {
		ArrayList<String> errores = new ArrayList<String>();
		
		if(Double.parseDouble(UploadPercentage.getText()) > 1 || Double.parseDouble(UploadPercentage.getText()) < 0 ){
			errores.add("Upload Frequency debe ser de 0 a 1.\n");
		}
		double sumaUP = Double.parseDouble(CorrectPer.getText())+
						Double.parseDouble(WrongPlacePer.getText())+
						Double.parseDouble(InsultPer.getText())+
						Double.parseDouble(SpammPer.getText())+
						Double.parseDouble(ViolentPer.getText())+
						Double.parseDouble(PornPer.getText());

		if(sumaUP > 1 || sumaUP < 0 ){
			errores.add("La suma de los valores de Upload Profile tiene que dar 1.\n");
		}
		double sumaView = Double.parseDouble(ForumPer.getText())+
						  Double.parseDouble(ReporterPer.getText())+
						  Double.parseDouble(MultimediaPer.getText());
		
		if(sumaView > 1 || sumaView < 0 ){
			errores.add("La suma de view profile tiene que dar 1.\n");
		}
		if(Double.parseDouble(WrongComplaintPer.getText()) > 1 || Double.parseDouble(WrongComplaintPer.getText()) < 0 ){
			errores.add("Wrong Placement Complaint percentage debe ser de 0 a 1.\n");
		}
		if(Double.parseDouble(InsultComplaintPer.getText()) > 1 || Double.parseDouble(InsultComplaintPer.getText()) < 0 ){
			errores.add("Insult complaint percentage debe ser de 0 a 1.\n");
		}
		if(Double.parseDouble(SpamComplaintPer.getText()) > 1 || Double.parseDouble(SpamComplaintPer.getText()) < 0 ){
			errores.add("Spam complaint percentage debe ser de 0 a 1.\n");
		}
		if(Double.parseDouble(ViolentComplaintPer.getText()) > 1 || Double.parseDouble(ViolentComplaintPer.getText()) < 0 ){
			errores.add("Violent complaint percentage debe ser de 0 a 1.\n");
		}
		if(Double.parseDouble(PornComplaintPer.getText()) > 1 || Double.parseDouble(PornComplaintPer.getText()) < 0 ){
			errores.add("Porn complaint percentage debe ser de 0 a 1.\n");
		}
		if(errores.size()>0){
			String errorMostrar = "";
			JOptionPane optionPane = new JOptionPane();
			for(int i = 0 ; i < errores.size() ; i++){
				errorMostrar = errorMostrar + errores.get(i);
			}
			optionPane.setMessage(errorMostrar);
			optionPane.setMessageType(JOptionPane.ERROR_MESSAGE);
			JDialog dialog = optionPane.createDialog(null, "Information Dialog");
			dialog.setVisible(true);
			return false;
		}else{
			return true;
		}
	}

	
	private void visualizarInformacionAgente() {
		try{
			for(int i  = 0 ; i < agente.size() ; i++ ){
				if(AgentCombo.getSelectedItem().equals(agente.get(i).getName()) && PopulationCombo.getSelectedItem().equals(agente.get(i).getPopulation())){
					
					UploadPercentage.setText(""+agente.get(i).getUp().getUpLoadContent());
					CorrectPer.setText(""+agente.get(i).getUp().getCorrect());
					WrongPlacePer.setText(""+agente.get(i).getUp().getWrongPlacement());
					InsultPer.setText(""+agente.get(i).getUp().getInsult());
					SpammPer.setText(""+agente.get(i).getUp().getSpam());
					ViolentPer.setText(""+agente.get(i).getUp().getViolent());
					PornPer.setText(""+agente.get(i).getUp().getPorn());
					
					ForumPer.setText(""+agente.get(i).getVp().getForum());
					ReporterPer.setText(""+agente.get(i).getVp().getTheReporter());
					MultimediaPer.setText(""+agente.get(i).getVp().getPhotoVideo());
					
					WrongComplaintPer.setText(""+agente.get(i).getCp().getWrongPlacement());
					InsultComplaintPer.setText(""+agente.get(i).getCp().getInsult());
					SpamComplaintPer.setText(""+agente.get(i).getCp().getSpam());
					ViolentComplaintPer.setText(""+agente.get(i).getCp().getViolent());
					PornComplaintPer.setText(""+agente.get(i).getCp().getPorn());
					
					NumberOfAgents.setText(""+agente.get(i).getQuantity());	

					switch(agente.get(i).getVp().getViewMode()){
						case 0:
							ByOrderRadio.setSelected(true);
							ByMostViewRadio.setSelected(false);
							ByRandomRadio.setSelected(false);
							break;
						case 1:
							ByMostViewRadio.setSelected(true);
							ByOrderRadio.setSelected(false);
							ByRandomRadio.setSelected(false);
							break;
						case 2:
							ByRandomRadio.setSelected(true);
							ByOrderRadio.setSelected(false);
							ByMostViewRadio.setSelected(false);
							break;
					}
				}

				if(agente.get(i).getName().equals("Moderate")){
					this.ModerateAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Pornographic")){
					this.PornoAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Rude")){
					this.RudeAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Spammer")){
					this.SpammerAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Troll")){
					this.TrollAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				if(agente.get(i).getName().equals("Violent")){
					this.ViolentAgentNumber.setText(""+agente.get(i).getQuantity());
				}
				
			}		
		}catch(Exception e){
		}
	}

	
	public ArrayList<Agent> getAgente (){
		return agente;
	}
}
