package social.context;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import social.content.IContent;

/**
 * Context data of the context
 * @author davidsanchezpinsach
 *
 */
public class ContextData {
	private int maxCommentsPhotoVideo = 11;
	private int maxCommentsForum = 11;
	private int maxCommentsTheReporter = 11;
	private int totalComments = maxCommentsPhotoVideo+maxCommentsForum+maxCommentsTheReporter;
	
	private int numColumns = maxCommentsPhotoVideo+maxCommentsForum+maxCommentsTheReporter+3;
	private int maxAgents = 10;
	private int numAgents = 0;	
	private int numRows = maxAgents*2+1;
	
	//Arraylist where the simulation put the contents 
	private List<IContent> listSectionTheReporter;
	private List<IContent> listSectionForum;
	private List<IContent> listSectionPhotoVideo;
	
	//Arraylist where the simulation put the contents 
	private List<IContent> mostViewListTheReporter;
	private List<IContent> mostViewListForum;
	private List<IContent> mostViewListPhotoVideo;
	
	//Type of view profile
	private int contentByOrder = 0;
	private int contentByMostViews = 1;
	private int contentByRandom = 2;
	
	//Random of the simulation
	private Random random;
	
	public ContextData(Random random){
		listSectionTheReporter = Collections.synchronizedList(new ArrayList<IContent>());
		listSectionForum = Collections.synchronizedList(new ArrayList<IContent>());
		listSectionPhotoVideo = Collections.synchronizedList(new ArrayList<IContent>());		
		mostViewListTheReporter = Collections.synchronizedList(new ArrayList<IContent>());
		mostViewListForum = Collections.synchronizedList(new ArrayList<IContent>());
		mostViewListPhotoVideo = Collections.synchronizedList(new ArrayList<IContent>());
		this.random = random;
		
	}
	public int getMaxCommentsPhotoVideo() {
		return maxCommentsPhotoVideo;
	}
	public void setMaxCommentsPhotoVideo(int maxCommentsPhotoVideo) {
		this.maxCommentsPhotoVideo = maxCommentsPhotoVideo;
	}
	public int getMaxCommentsForum() {
		return maxCommentsForum;
	}
	public void setMaxCommentsForum(int maxCommentsForum) {
		this.maxCommentsForum = maxCommentsForum;
	}
	public int getMaxCommentsTheReporter() {
		return maxCommentsTheReporter;
	}
	public void setMaxCommentsTheReporter(int maxCommentsTheReporter) {
		this.maxCommentsTheReporter = maxCommentsTheReporter;
	}
	public int getTotalComments() {
		return totalComments;
	}
	public void setTotalComments(int totalComments) {
		this.totalComments = totalComments;
	}
	public int getNumColumns() {
		return numColumns;
	}
	public void setNumColumns(int numColumns) {
		this.numColumns = numColumns;
	}
	public int getMaxAgents() {
		return maxAgents;
	}
	public void setMaxAgents(int maxAgents) {
		this.maxAgents = maxAgents;
	}
	public int getNumAgents() {
		return numAgents;
	}
	public void setNumAgents(int numAgents) {
		this.numAgents = numAgents;
	}
	public int getNumRows() {
		return numRows;
	}
	public void setNumRows(int numRows) {
		this.numRows = numRows;
	}
	
	
	public int getContentByRandom() {
		return contentByRandom;
	}
	public void setContentByRandom(int contentByRandom) {
		this.contentByRandom = contentByRandom;
	}
	//Methods of the list of categories
	public void addContentListSectionTheReporter(IContent content){
		listSectionTheReporter.add(0,content);
	}
	public IContent getContentListSectionTheReporter(int index){
		return listSectionTheReporter.get(index);
	}
	public void removeContentListSectionTheReporter(int index){
		listSectionTheReporter.remove(index);
	}
	public void removeContentListSectionTheReporter(IContent content){
		listSectionTheReporter.remove(content);
	}
	public void addContentListSectionForum(IContent content){
		listSectionForum.add(0,content);
	}
	public IContent getContentListSectionForum(int index){
		return listSectionForum.get(index);
	}
	public void removeContentListSectionForum(int index){
		listSectionForum.remove(index);
	}
	public void removeContentListSectionForum(IContent content){
		listSectionForum.remove(content);
	}
	public void addContentListSectionPhotoVideo(IContent content){
		listSectionPhotoVideo.add(0,content);
	}
	public IContent getContentListSectionPhotoVideo(int index){
		return listSectionPhotoVideo.get(index);
	}
	public void removeContentListSectionPhotoVideo(int index){
		listSectionPhotoVideo.remove(index);
	}
	public void removeContentListSectionPhotoVideo(IContent content){
		listSectionPhotoVideo.remove(content);
	}
	
	public void showList(List<IContent> list){
		System.out.println("--Mostrando lista ordenada--");
		for(IContent content : list){
			System.out.println("Views: "+content.getNumViews());
		}
		System.out.println("--Fi lista ordenada--");
	}
	
	public int getPos(IContent content, List<IContent> list){
		int i = 0, pos = 0;
		if(list.size() != 0){
			i = list.size()-1;
			while((i>=0 )&&(list.get(i).getNumViews() <= content.getNumViews())){
				pos = i;
				i--;
			}
		}
		return pos;
	}
	
	public void upDateView(List<IContent> list, int pos){
		IContent content = list.get(pos);
		content.setNumViews(content.getNumViews() + 1);
		list.remove(content);
		int newPos = getPos(content, list);
		list.add(newPos, content);
		showList(list);
	}
	
	//TODO
	//Methods of mostViewContents
	public void addContentMostViewTheReporter(IContent content){
		mostViewListTheReporter.add(content);
	}
	public IContent getContentMostViewTheReporter(int index){
		return mostViewListTheReporter.get(index);
	}
	public void removeContentMostViewTheReporter(int index){
		mostViewListTheReporter.remove(index);
	}
	public void removeContentMostViewTheReporter(IContent content){
		mostViewListTheReporter.remove(content);
	}
	
	public void addContentMostViewForum(IContent content){
		mostViewListForum.add(content);	
	}
	public IContent getContentMostViewForum(int index){
		return mostViewListForum.get(index);
	}
	public void removeContentMostViewForum(int index){
		mostViewListForum.remove(index);
	}
	public void removeContentMostViewForum(IContent content){
		mostViewListForum.remove(content);
	}
	public void addContentMostViewPhotoVideo(IContent content){
		mostViewListPhotoVideo.add(content);	
	}
	public IContent getContentMostViewPhotoVideo(int index){
		return mostViewListPhotoVideo.get(index);
	}
	public void removeContentMostViewPhotoVideo(int index){
		mostViewListPhotoVideo.remove(index);
	}
	public void removeContentMostViewPhotoVideo(IContent content){
		mostViewListPhotoVideo.remove(content);
	}
	
	//Getters and Setters of the different list
	public List<IContent> getListSectionTheReporter() {
		return listSectionTheReporter;
	}
	public void setListSectionTheReporter(List<IContent> listSectionTheReporter) {
		this.listSectionTheReporter = listSectionTheReporter;
	}
	public List<IContent> getListSectionForum() {
		return listSectionForum;
	}
	public void setListSectionForum(List<IContent> listSectionForum) {
		this.listSectionForum = listSectionForum;
	}
	public List<IContent> getListSectionPhotoVideo() {
		return listSectionPhotoVideo;
	}
	public void setListSectionPhotoVideo(List<IContent> listSectionPhotoVideo) {
		this.listSectionPhotoVideo = listSectionPhotoVideo;
	}
	public List<IContent> getMostViewListTheReporter() {
		return mostViewListTheReporter;
	}
	public void setMostViewListTheReporter(List<IContent> mostViewListTheReporter) {
		this.mostViewListTheReporter = mostViewListTheReporter;
	}
	public List<IContent> getMostViewListForum() {
		return mostViewListForum;
	}
	public void setMostViewListForum(List<IContent> mostViewListForum) {
		this.mostViewListForum = mostViewListForum;
	}
	public List<IContent> getMostViewListPhotoVideo() {
		return mostViewListPhotoVideo;
	}
	public void setMostViewListPhotoVideo(List<IContent> mostViewListPhotoVideo) {
		this.mostViewListPhotoVideo = mostViewListPhotoVideo;
	}
	public int getContentByOrder() {
		return contentByOrder;
	}
	public void setContentByOrder(int contentByOrder) {
		this.contentByOrder = contentByOrder;
	}
	public int getContentByMostViews() {
		return contentByMostViews;
	}
	public void setContentByMostViews(int contentByMostViews) {
		this.contentByMostViews = contentByMostViews;
	}
	//Method to get random integers
	public int nextIntRandom(int x){
		return random.nextInt(x);
	}
}
