package social.distribution;

import java.util.List;
import org.apache.commons.math3.distribution.GammaDistribution;
import social.content.IContent;

/**
 * Gamma distribution
 * @author Iosu mendizabal
 * Modified by davidSanchezPinsach
 */
public class Gamma {
	private double k = 0;
	private double theta = 0;
	private double sample = 0;
	private int num = 0;
	private int size;

	/*
	 * Get num using gamma distribution
	 */
	public int getNum(List<IContent> list) {	
		k = 1;
		size = list.size();
		if(size < 2){
			num = 0;
		}else{
			theta = list.size()/2;
			GammaDistribution gd = new GammaDistribution(k, theta);
			do{
				sample = gd.sample();
			}while(sample > theta);
			num = roundNumber(sample);
		}
		return num;
	}
	
	/*
	 * Function to round number
	 */
	private int roundNumber(double numero) {
		return (int) Math.floor(numero);
	}
}
